/*******************************************************************************
*	filename	:	override.cpp
*	version		:	20060927
*	subversion	:	
*	
*	copyright	:	0x0D/0x20I
*		460	(gdi++.dllX)
*		168	(gdi++.dllX 2pt)
*		PicoPicoKHZGNI
*	
*	history :
*		2006/09/27	{Ver.20060927
*		2006/09/30	168ɂǁBڍׂmemo.txtB
*		2006/10/02	̃Rg̍쐬 by PicoPicoKHZGNI
*******************************************************************************/

/*******************************************************************************
*	vvZbT
*******************************************************************************/
#define MAX_EXCLUDES 32
//#define __MMX__	//64bitpbNhZgpBMMX-Pentiumȍ~
//#define __SSE__	//MMX2̒ǉA128bitpbNhZBPen3ȍ~
//#define __SSE2__	//128bitpbNhZBPen4AAthlon64ȍ~
//#define __SSE3__	//SSE2ƉǁBPrescottAVeniceȍ~
//#define __SSE4__	//SSE3ƉǁBCore2 ȍ~

/*******************************************************************************
*	wb_t@C̃CN[h - 
*******************************************************************************/
#include "override.h"

#pragma comment(lib, "Gdi32.lib")
#pragma comment(lib, "User32.lib")

/*******************************************************************************
*	O[oۂϐ&萔̐錾
*******************************************************************************/
UINT g_Quality = 0;
UINT g_Weight = 0;
UINT g_Enhance = 0;
UINT g_UseSubPixel = 0;
UINT g_SubPixelDirection = 0;
float g_MaxHeight = 0;
UINT g_ForceAntialiasedQuality = 0;
BOOL g_IsWinXPorLater = FALSE;
int  g_Scale = 1;
CTlsData<ETOCache> g_Cache;

/*******************************************************************************
*	vZ⏕
*******************************************************************************/
int div_ceil(int a, int b){
	if(a % b) return (a>0)? (a/b+1): (a/b-1);
	return a / b;
}

/*******************************************************************************
*	̃nbV
*******************************************************************************/
template <int BUFSIZE = LF_FACESIZE, bool ignoreCase = false>
struct StringHashT {
private:
	DWORD	hash;
	WCHAR	name[BUFSIZE];
public:
	StringHashT() {}
	StringHashT(LPCWSTR s) {
		Init(s);
	}
	void Init(LPCWSTR s) {
		wcsncpy(name, s, BUFSIZE);
		_UpdateHash();
	}
	bool operator ==(const StringHashT<BUFSIZE, ignoreCase>& x) const {
		if(ignoreCase)
			return !(hash != x.hash || _wcsicmp(name, x.name) != 0); // VC2005łwcsicmp͌xo܂B
		else
			return !(hash != x.hash || wcscmp(name, x.name) != 0);
	}
	DWORD Hash() const {
		return hash;
	}
	LPCWSTR c_str() const {
		return name;
	}
	void _UpdateHash() {
		DWORD dw = 0;
		LPWSTR p;
		for (p = name; *p; p++) {
			dw <<= 3;
			if(ignoreCase)
				dw ^= (WORD)CharLowerW((LPWSTR)*p);
			else
				dw ^= *p;
		}
		hash = dw;
	}
};

typedef StringHashT<>				StringHash;
typedef StringHashT<MAX_PATH,true>	StringHashMod;
StringHash g_ExcludeList[MAX_EXCLUDES];
StringHashMod g_ExcludeMod[MAX_EXCLUDES];

/*******************************************************************************
*	INIt@C̓ǂݍ
*******************************************************************************/
void LoadSettings(HMODULE hModule){
	WCHAR szFileName[MAX_PATH + 1] = L"";
	// DLL̃tpX擾
	GetModuleFileName(hModule, szFileName, MAX_PATH);
	// gq".ini"ɒu
	lstrcpy(szFileName + lstrlen(szFileName) - 3, L"ini");
	// eݒǂݍ
	// INIt@C̗:
	// [General]
	// Quality=1
	// Weight=0
	// Enhance=0
	// UseSubPixel=0
	// SubPixelDirection=0
	// MaxHeight=0
	// ForceAntialiasedQuality=0
	g_Quality = GetPrivateProfileInt(L"General",L"Quality",2,szFileName);
	g_Weight = GetPrivateProfileInt(L"General",L"Weight",0,szFileName);
  	g_Enhance = GetPrivateProfileInt(L"General",L"Enhance",0,szFileName);
	g_UseSubPixel = GetPrivateProfileInt(L"General",L"UseSubPixel",0,szFileName);
	g_SubPixelDirection = GetPrivateProfileInt(L"General",L"SubPixelDirection",0,szFileName);
	g_MaxHeight = (float)GetPrivateProfileInt(L"General",L"MaxHeight",0,szFileName);
	g_ForceAntialiasedQuality = GetPrivateProfileInt(L"General",L"ForceAntialiasedQuality",0,szFileName);
	if(g_UseSubPixel)
		g_Quality = 2;

	// OS̃o[WXPȍ~ǂ
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&osvi);
	g_IsWinXPorLater = ((osvi.dwMajorVersion > 5) || ((osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion >= 1)));

	// [Exclude]ZNV珜OtHgXgǂݍ
	memset(&g_ExcludeList, 0, sizeof(g_ExcludeList));

/*	switch(g_Quality) {
	case 3:  g_Scale = 4; break;
	case 2:  g_Scale = 3; break;
	case 1:  g_Scale = 2; break;
	default: g_Scale = 1; break;
	}
*/
	g_Scale=8;
	
	const int cch = 65536;
	WCHAR*  buffer = (LPWSTR)calloc(sizeof(WCHAR), cch);
	if(!buffer)
		return;

	WCHAR* p = buffer;
	UINT   nb = 0;
	*p = '\0';
	GetPrivateProfileSection(L"Exclude", p, cch, szFileName);
	while(*p) {
		bool b = false;
		StringHash* exclist = g_ExcludeList;
		StringHash str(p);
		for(UINT i=0 ; i < nb ; i++) {
			if(exclist[i] == str) {
				b = true;
				break;
			}
		}
		if(!b) {
			if(nb < MAX_EXCLUDES) {
				exclist[nb++] = str;
			}
		}
		while(*p) p++;
		p++;
	}

	p = buffer;
	nb = 0;
	*p = '\0';
	GetPrivateProfileSection(L"ExcludeModule", p, cch, szFileName);
	while(*p) {
		bool b = false;
		StringHashMod* exclist = g_ExcludeMod;
		StringHashMod str(p);
		for(UINT i=0 ; i < nb ; i++) {
			if(exclist[i] == str) {
				b = true;
				break;
			}
		}
		if(!b) {
			if(nb < MAX_EXCLUDES) {
				exclist[nb++] = str;
			}
		}
		while(*p) p++;
		p++;
	}
	free(buffer);
}

/*******************************************************************************
*	Is``֐
*******************************************************************************/
// tHgAEgCtHg`FbN
BOOL IsOutlineFont(HDC hdc)
{
	OUTLINETEXTMETRIC otm = { sizeof(OUTLINETEXTMETRIC) };
	return GetOutlineTextMetrics(hdc, otm.otmSize, &otm);
}

// tHgOXgɓĂ邩`FbN
BOOL IsFontExcluded(const LPCWSTR lpszFaceName){
	StringHash* exclist = g_ExcludeList;
	StringHash str(lpszFaceName);
	for(UINT i=0 ; i < MAX_EXCLUDES && exclist[i].Hash() ; i++) {
		if(exclist[i] == str)
			return TRUE;
	}
	return FALSE;
}
// 񃆃jR[h
BOOL IsFontExcluded(const LPCSTR lpszFaceName){
	int bufferLength = MultiByteToWideChar(CP_ACP, 0, lpszFaceName, LF_FACESIZE, 0, 0);
	LPWSTR lpszUnicode = (LPWSTR)malloc(bufferLength * 2);
	MultiByteToWideChar(CP_ACP, 0, lpszFaceName, LF_FACESIZE, lpszUnicode, bufferLength);
	BOOL b = IsFontExcluded(lpszUnicode);
	free(lpszUnicode);
	return b;
}

// vZXOXgɓĂ邩`FbN
BOOL IsProcessExcluded()
{
	//̕ӎQƁhttp://www.catch22.net/tuts/undoc01.asp
	STARTUPINFOW si = { sizeof(STARTUPINFOW) };
	GetStartupInfo(&si);
	if(si.cbReserved2 == sizeof(int) + sizeof(FOURCC)) {
		FOURCC* pMagic = (FOURCC*)((BYTE*)si.lpReserved2 + sizeof(int));
		if (*pMagic == CREATEPROCESS_MAGIC)
			return FALSE;
	}

	StringHashMod* exclist = g_ExcludeMod;
	for(UINT i=0 ; i < MAX_EXCLUDES && exclist[i].Hash() ; i++) {
		if(GetModuleHandleW(exclist[i].c_str()))
			return TRUE;
	}
	return FALSE;
}

// LDCǂ`FbN
BOOL IsValidDC(const HDC hdc){
	if (GetDeviceCaps(hdc, TECHNOLOGY) != DT_RASDISPLAY) return FALSE;
	if (!IsOutlineFont(hdc)) return FALSE;	// rbg}bvtHge
	// ŃtHg`FbNs
	WCHAR szFaceName[LF_FACESIZE] = L"";
	GetTextFaceW(hdc, LF_FACESIZE, szFaceName);
	if (IsFontExcluded(szFaceName)) return FALSE;
	return TRUE;
}


/*******************************************************************************
*	֊stB^
*******************************************************************************/

/*

const static BYTE saturated_sum[256*2] = {
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07, 0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
  0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17, 0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,
  0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27, 0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,
  0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37, 0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,
  0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47, 0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,
  0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57, 0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,
  0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67, 0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,
  0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77, 0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,
  0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87, 0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,
  0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97, 0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,
  0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7, 0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,
  0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7, 0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,0xbf,
  0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7, 0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,
  0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7, 0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,
  0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7, 0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,
  0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7, 0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
  0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};
#define adds(var, val)	((var) = saturated_sum[(var) + (val) + 128])
#define subs(var, val)	((var) = saturated_sum[(var) - (val) + 128])

void EnhanceEdges(ETOCache* pCache, BYTE* lpPixels, int width, int height)
{
  	if (g_Enhance <= 0)      return;
        else if (g_Enhance > 4)  g_Enhance = 4;

        int  srcWidthBytes = pCache->Size().cx * 4;
	int  dstSkipBytes  = srcWidthBytes - (width*4 / g_Scale);
        int  w = (width*4 / g_Scale) + dstSkipBytes;
        register BYTE* dst;

        width  /= g_Scale;
        height /= g_Scale;
        dst = lpPixels + w;
        for(int y=1 ; y < height-1 ; y++) {
            register signed char* hdif = (signed char *)dst + srcWidthBytes * height;
            register signed char* vdif = hdif + srcWidthBytes * height;
            dst+=4; hdif+=4; vdif+=4;
            for (int x = 1 ; x < width-1 ; x++) {
                int ratio = (7 - g_Enhance) * 2;
                if (g_UseSubPixel == 0) {
                    hdif[0] = ((dst[0] << 1) - dst[-4]   - dst[4])   / ratio;
                    hdif[1] = ((dst[1] << 1) - dst[-3]   - dst[5])   / ratio;
                    hdif[2] = ((dst[2] << 1) - dst[-2]   - dst[6])   / ratio;
                }
                vdif[0] = ((dst[0] << 1) - dst[-w]   - dst[w])   / ratio;
                vdif[1] = ((dst[1] << 1) - dst[-w+1] - dst[w+1]) / ratio;
                vdif[2] = ((dst[2] << 1) - dst[-w+2] - dst[w+2]) / ratio;
                dst+=4; hdif+=4; vdif+=4;
            }
            dst += dstSkipBytes + 4;
        }
        dst = lpPixels + w;
        for(int y=1 ; y < height-1 ; y++) {
            register signed char* hdif = (signed char *)dst + srcWidthBytes * height;
            register signed char* vdif = hdif + srcWidthBytes * height;
            dst+=4; hdif+=4; vdif+=4;
            for (int x = 1 ; x < width-1 ; x++) {
                if (g_UseSubPixel == 0) {
                    subs(dst[-4], hdif[0] / 2);  adds(dst[0], hdif[0]);  subs(dst[4],  hdif[0] / 2);
                    subs(dst[-3], hdif[1] / 2);  adds(dst[1], hdif[1]);  subs(dst[5],  hdif[1] / 2);
                    subs(dst[-2], hdif[2] / 2);  adds(dst[2], hdif[2]);  subs(dst[6],  hdif[2] / 2);
                }
                subs(dst[-w],  vdif[0] / 2);   adds(dst[0], vdif[0]);   subs(dst[w],   vdif[0] / 2);
                subs(dst[1-w], vdif[1] / 2);   adds(dst[1], vdif[1]);   subs(dst[w+1], vdif[1] / 2);
                subs(dst[2-w], vdif[2] / 2);   adds(dst[2], vdif[2]);   subs(dst[w+2], vdif[2] / 2);
                dst+=4; hdif+=4; vdif+=4;
            }
            dst += dstSkipBytes + 4;
        }
}
*/

/*******************************************************************************
*	DIB̏k
*******************************************************************************/
void  ReductDIB(ETOCache* pCache, BYTE* lpBufferPixels, BYTE* lpCanvasPixels, int CanvasWidth, int CanvasHeight,COLORREF FontColor)
{
	
	int BufferWidth = CanvasWidth /8; //Pʂ̓sNZ
	int BufferHeight = CanvasHeight /8; //Pʂ̓sNZ
	int BufferLineSize = pCache->Size(NUM_ETO_BUFFER).cx; //Pʂ̓sNZ
	int CanvasLineSize = pCache->Size(NUM_ETO_CANVAS).cx; //Pʂ̓sNZ
//	if(CanvasLineSize % 32)CanvasLineSize += 32 - (CanvasLineSize % 32);
	int BufferLineSizeByte = BufferLineSize *4; //Pʂ̓oCg
	int CanvasLineSizeByte = CanvasLineSize /8; //Pʂ̓oCg

	BYTE fcB = (BYTE)( (FontColor & 0x00FF0000) >> 16);
	BYTE fcG = (BYTE)( (FontColor & 0x0000FF00) >> 8 );
	BYTE fcR = (BYTE)( (FontColor & 0x000000FF)      );
/*
	BYTE EightBit;
	float Alpha;

	for(int i_y = 0;i_y<BufferHeight;i_y++){
		for(int i_x = 0;i_x<BufferWidth;i_x++){
			int BufferCurPos = (i_x + i_y * BufferLineSize) * 4;
			int CanvasCurPos = i_x + i_y * CanvasLineSize/8*8;
			
			Alpha = 0.0f;
			for(int j = 0;j < 7; j++){
				EightBit = lpCanvasPixels[CanvasCurPos + j*CanvasLineSize/8];
				if(EightBit & 0x01)Alpha += 1/64.0f;
				if(EightBit & 0x02)Alpha += 1/64.0f;
				if(EightBit & 0x04)Alpha += 1/64.0f;
				if(EightBit & 0x08)Alpha += 1/64.0f;
				if(EightBit & 0x10)Alpha += 1/64.0f;
				if(EightBit & 0x20)Alpha += 1/64.0f;
				if(EightBit & 0x40)Alpha += 1/64.0f;
				if(EightBit & 0x80)Alpha += 1/64.0f;
				}
			
			lpBufferPixels[BufferCurPos+0] = (BYTE)(lpBufferPixels[BufferCurPos+0] * (1.0f-Alpha) + fcB*Alpha);
			lpBufferPixels[BufferCurPos+1] = (BYTE)(lpBufferPixels[BufferCurPos+1] * (1.0f-Alpha) + fcG*Alpha);
			lpBufferPixels[BufferCurPos+2] = (BYTE)(lpBufferPixels[BufferCurPos+2] * (1.0f-Alpha) + fcR*Alpha);
			lpBufferPixels[BufferCurPos+3] = 0;
			
		}
	}
*/
	DWORD c_01110111b[4] = { 0x77777777,0x77777777,0x77777777,0x77777777 };
	DWORD c_00001111b[4] = { 0x0f0f0f0f,0x0f0f0f0f,0x0f0f0f0f,0x0f0f0f0f };
	WORD c_fontcolor[8] = { fcB,fcG,fcR,0, fcB,fcG,fcR,0 };
	for(int i_y = 0;i_y<BufferHeight;i_y++){
		int i_y_buf = i_y * BufferLineSizeByte;
		int i_y_can = i_y * CanvasLineSizeByte *8;
		int bwd16 = BufferWidth/16;
		if(BufferWidth % 16)bwd16++;
		for(int i_x = 0;i_x<bwd16;i_x++){
			DWORD BufferCurPos = (DWORD)lpBufferPixels + (i_x << 6) + i_y_buf ;
			DWORD CanvasCurPos = (DWORD)lpCanvasPixels + (i_x << 4) + i_y_can;
			__asm
			{
				//***************************************canvas8*8̃rbg𐔂
				movdqu	xmm7 , c_01110111b
				movdqu	xmm6 , c_00001111b
				movdqu	xmm0 , c_fontcolor

				mov		eax , BufferCurPos
				mov		ebx , CanvasCurPos

				pxor	xmm1 , xmm1

				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte
				//***************************line 0
				movdqa	xmm3 , [ebx]
				movdqu	xmm2 , xmm3 //
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				psrlw	xmm3 , 1
				pand	xmm3 , xmm7
				psubb	xmm2 , xmm3
				movdqu	xmm3 , xmm2 
				psrlw	xmm3 , 4
				paddb	xmm2 , xmm3
				pand	xmm2 , xmm6
				paddusb	xmm1 , xmm2
				add		ebx , CanvasLineSizeByte

				//***************************************At@uh
				pxor		xmm7 , xmm7

				//***************************line 0
				movdqu		xmm2 , xmm1
				punpcklbw	xmm2 , xmm2
				punpcklwd	xmm2 , xmm2
				movdqu		xmm3 , xmm2
				punpckhbw	xmm2 , xmm7 //alpha[0,1]
				punpcklbw	xmm3 , xmm7 //alpha[2,3]
				movdqa		xmm4 , [eax]
				movdqu		xmm5 , xmm4
				punpckhbw	xmm4 , xmm7 //dest[0,1]
				punpcklbw	xmm5 , xmm7 //dest[2,3]
				movdqu		xmm6 , xmm4	//(L)
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm2 
				psraw		xmm6 , 6 
				psubsw		xmm4 , xmm6 //dest - (dest - src)*alpha
				movdqu		xmm6 , xmm5
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm3 
				psraw		xmm6 , 6 
				psubsw		xmm5 , xmm6 //dest - (dest - src)*alpha
				packuswb	xmm5 , xmm4
				movdqa		[eax] , xmm5
				add			eax , 16
				psrldq		xmm1 , 4 //Pʂ̓oCg
				//***************************line 0
				movdqu		xmm2 , xmm1
				punpcklbw	xmm2 , xmm2
				punpcklwd	xmm2 , xmm2
				movdqu		xmm3 , xmm2
				punpckhbw	xmm2 , xmm7 //alpha[0,1]
				punpcklbw	xmm3 , xmm7 //alpha[2,3]
				movdqa		xmm4 , [eax]
				movdqu		xmm5 , xmm4
				punpckhbw	xmm4 , xmm7 //dest[0,1]
				punpcklbw	xmm5 , xmm7 //dest[2,3]
				movdqu		xmm6 , xmm4	//(L)
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm2 
				psraw		xmm6 , 6 
				psubsw		xmm4 , xmm6 //dest - (dest - src)*alpha
				movdqu		xmm6 , xmm5
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm3 
				psraw		xmm6 , 6 
				psubsw		xmm5 , xmm6 //dest - (dest - src)*alpha
				packuswb	xmm5 , xmm4
				movdqa		[eax] , xmm5
				add			eax , 16
				psrldq		xmm1 , 4 //Pʂ̓oCg
				//***************************line 0
				movdqu		xmm2 , xmm1
				punpcklbw	xmm2 , xmm2
				punpcklwd	xmm2 , xmm2
				movdqu		xmm3 , xmm2
				punpckhbw	xmm2 , xmm7 //alpha[0,1]
				punpcklbw	xmm3 , xmm7 //alpha[2,3]
				movdqa		xmm4 , [eax]
				movdqu		xmm5 , xmm4
				punpckhbw	xmm4 , xmm7 //dest[0,1]
				punpcklbw	xmm5 , xmm7 //dest[2,3]
				movdqu		xmm6 , xmm4	//(L)
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm2 
				psraw		xmm6 , 6 
				psubsw		xmm4 , xmm6 //dest - (dest - src)*alpha
				movdqu		xmm6 , xmm5
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm3 
				psraw		xmm6 , 6 
				psubsw		xmm5 , xmm6 //dest - (dest - src)*alpha
				packuswb	xmm5 , xmm4
				movdqa		[eax] , xmm5
				add			eax , 16
				psrldq		xmm1 , 4 //Pʂ̓oCg
				//***************************line 0
				movdqu		xmm2 , xmm1
				punpcklbw	xmm2 , xmm2
				punpcklwd	xmm2 , xmm2
				movdqu		xmm3 , xmm2
				punpckhbw	xmm2 , xmm7 //alpha[0,1]
				punpcklbw	xmm3 , xmm7 //alpha[2,3]
				movdqa		xmm4 , [eax]
				movdqu		xmm5 , xmm4
				punpckhbw	xmm4 , xmm7 //dest[0,1]
				punpcklbw	xmm5 , xmm7 //dest[2,3]
				movdqu		xmm6 , xmm4	//(L)
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm2 
				psraw		xmm6 , 6 
				psubsw		xmm4 , xmm6 //dest - (dest - src)*alpha
				movdqu		xmm6 , xmm5
				psubsw		xmm6 , xmm0 
				pmullw		xmm6 , xmm3 
				psraw		xmm6 , 6 
				psubsw		xmm5 , xmm6 //dest - (dest - src)*alpha
				packuswb	xmm5 , xmm4
				movdqa		[eax] , xmm5
				add			eax , 16
				psrldq		xmm1 , 4 //Pʂ̓oCg
				

			}
		}
	}

}
/*******************************************************************************
*	BufferhԂ
*******************************************************************************/
void  FillBuffer(ETOCache* pCache, BYTE* lpBufferPixels, int BufferWidth, int BufferHeight,COLORREF FontColor)
{
	DWORD* lpdwBufferPixels = (DWORD*)lpBufferPixels;
	BYTE FontColorB = (BYTE)( (FontColor & 0x00FF0000) >> 16);
	BYTE FontColorG = (BYTE)( (FontColor & 0x0000FF00) >> 8 );
	BYTE FontColorR = (BYTE)( (FontColor & 0x000000FF)      );
	DWORD dwColor = (FontColorR<<16) | (FontColorG<<8) | FontColorB;
	int BufferLineSize = pCache->Size(NUM_ETO_BUFFER).cx;

	for(int i_y = 0;i_y<BufferHeight;i_y++){
		for(int i_x = 0;i_x<BufferWidth;i_x++){
			lpdwBufferPixels[i_x + i_y * BufferLineSize] = dwColor;
		}
	}
	
}
/*******************************************************************************
*	Canvas[NA
*******************************************************************************/
void  ZeroCanvas(ETOCache* pCache, BYTE* lpCanvasPixels, int CanvasWidth, int CanvasHeight)
{
	DWORD* lpdwCanvasPixels = (DWORD*)lpCanvasPixels;
	int CanvasLineSize = pCache->Size(NUM_ETO_CANVAS).cx;
//	if(CanvasLineSize % 32)CanvasLineSize += 32 - (CanvasLineSize % 32);
	
	for(int i_y = 0;i_y<CanvasHeight;i_y++){
		for(int i_x = 0;i_x<CanvasWidth / 32;i_x++){
			lpdwCanvasPixels[i_x + i_y * CanvasLineSize/32] = 0;
		}
	}
	
}


/*******************************************************************************
*	ETOCache
*******************************************************************************/
HDC ETOCache::CreateDC(int num)
{
	if(!hdc[num])
		hdc[num] = CreateCompatibleDC(NULL);
	return hdc[num];
}

HBITMAP ETOCache::CreateDIB(int num, int width, int height, int BitCount, BYTE** lplpPixels){

	int size_alignment = 128/BitCount; 
	if(width % size_alignment)width += size_alignment - (width % size_alignment);//128bitACg
	width += 128/BitCount;//128bit}[W

	if(dibSize[num].cx < width || dibSize[num].cy < height) {
		if(dibSize[num].cx > width)  width = dibSize[num].cx;
		if(dibSize[num].cy > height) height = dibSize[num].cy;
		BITMAPINFOHEADER bmiHeader = {sizeof(bmiHeader), width, -height, 1, BitCount, BI_RGB,};

		HBITMAP hbmpNew = CreateDIBSection(CreateDC(num), (CONST BITMAPINFO*)&bmiHeader, DIB_RGB_COLORS, (LPVOID*)lplpPixels, NULL, 0);
		if(!hbmpNew)return NULL;

		//shbmpNew==NULL̏ꍇz肵AƂ̂݃LbVXV
		if(hbmp[num])DeleteObject(hbmp[num]);

		DWORD address = (DWORD)*lplpPixels;
		if(address % 16)address += 16 - (address % 16);//128bitACg
		*lplpPixels = (BYTE*)address;

		hbmp[num] = hbmpNew;
		dibSize[num].cx = width;
		dibSize[num].cy = height;
		lpPixels[num] = *lplpPixels;
	}
	*lplpPixels = lpPixels[num];
	return hbmp[num];
}

void ETOCache::FillSolidRect(int num, COLORREF rgb, const RECT* lprc)
{
	rgb = RGB(GetBValue(rgb), GetGValue(rgb), GetRValue(rgb));
	DWORD* p = (DWORD*)lpPixels[num];
	DWORD* pend = p + (dibSize[num].cx * dibSize[num].cy);
	while(p < pend)
		*p++ = rgb;
}

/*******************************************************************************
*	APItbN̂߂̃vvZbT
*******************************************************************************/
BOOL WINAPI _RealGetTextExtentPoint32A(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize, const TEXTMETRICA* lptm = NULL, INT* lpDx = NULL);
BOOL WINAPI _RealGetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize, const TEXTMETRICW* lptm = NULL, INT* lpDx = NULL);

#if 0//#ifdef _DEBUG
void dbg_GetTextExtentPoint32W(LPCSTR name, LPCWSTR psz, int cch, LPSIZE lpSize)
{
	LPWSTR pTmp = new WCHAR[cch+1];
	memcpy(pTmp, psz, cch * sizeof(WCHAR));
	pTmp[cch] = 0;
	if(lpSize) {
		TRACE(_T("%hs(\"%ls\", {%d,%d})\n"), name, pTmp, lpSize->cx, lpSize->cy);
	} else {
		TRACE(_T("%hs(\"%ls\", <null>)\n"), name, pTmp);
	}
	delete[] pTmp;
}
void dbg_GetTextExtentPoint32A(LPCSTR name, LPCSTR psz, int cch, LPSIZE lpSize)
{
	LPWSTR pTmp = new WCHAR[cch * 2 + 1];
	cch = MultiByteToWideChar(CP_ACP, 0, psz, cch, pTmp, cch * 2 + 1);
	dbg_GetTextExtentPoint32W(name, pTmp, cch, lpSize);
	delete[] pTmp;
}
#else
#define dbg_GetTextExtentPoint32A(a,b,c,d)
#define dbg_GetTextExtentPoint32W(a,b,c,d)
#endif

#define HOOK_DEFINE(dll, rettype, name, argtype, vars) \
	rettype WINAPI IMPL_##name argtype \
	{ \
	if ((g_Quality == 0) || (!IsValidDC(hdc))) return ORIG_##name vars; \
	int grmode = GetGraphicsMode(hdc); \
	if(grmode != GM_ADVANCED) \
		SetGraphicsMode(hdc, GM_ADVANCED); \
	XFORM xformOrig; \
	GetWorldTransform(hdc, &xformOrig); \
	rettype b = FALSE; \
	if (xformOrig.eM12 < -0.1f || 0.1f < xformOrig.eM12 || \
	    xformOrig.eM21 < -0.1f || 0.1f < xformOrig.eM21) { \
		b = _Real##name vars; /* ORIG_##name vars; */\
	} else { \
		XFORM xformScale = { \
			xformOrig.eM11 * g_Scale, xformOrig.eM12 * g_Scale, \
			xformOrig.eM21 * g_Scale, xformOrig.eM22 * g_Scale, \
			xformOrig.eDx  * g_Scale, xformOrig.eDy  * g_Scale  \
		}; \
		SetWorldTransform(hdc, &xformScale); \
		b = _Real##name vars; /*ORIG_##name vars; */\
		SetWorldTransform(hdc, &xformOrig); \
	} \
	if(grmode != GM_ADVANCED) \
		SetGraphicsMode(hdc, grmode); \
	dbg_##name(#name, lpString, cbString, lpSize); \
	return b; \
	}

/*
HOOK_DEFINE(user32.dll, DWORD, GetTabbedTextExtentA, (HDC hdc, LPCSTR lpString, int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions), (hdc, lpString, nCount, nTabPositions, lpnTabStopPositions))
HOOK_DEFINE(user32.dll, DWORD, GetTabbedTextExtentW, (HDC hdc, LPCWSTR lpString, int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions), (hdc, lpString, nCount, nTabPositions, lpnTabStopPositions))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentExPointA, (HDC hdc, LPCSTR lpszStr, int cchString, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize), (hdc, lpszStr, cchString, nMaxExtent, lpnFit, lpDx, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentExPointW, (HDC hdc, LPCWSTR lpszStr, int cchString, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize), (hdc, lpszStr, cchString, nMaxExtent, lpnFit, lpDx, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentExPointI, (HDC hdc, LPWORD pgiIn, int cgi, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize), (hdc, pgiIn, cgi, nMaxExtent, lpnFit, lpDx, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPointA, (HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize), (hdc, lpString, cbString, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPointW, (HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize), (hdc, lpString, cbString, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPointI, (HDC hdc, LPWORD pgiIn, int cgi, LPSIZE lpSize), (hdc, pgiIn, cgi, lpSize))
*/

//firefox
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPoint32A, (HDC hdc, LPCSTR  lpString, int cbString, LPSIZE lpSize), (hdc, lpString, cbString, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPoint32W, (HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize), (hdc, lpString, cbString, lpSize))
#undef HOOK_DEFINE

/*******************************************************************************
*	APItbN
*******************************************************************************/
BOOL WINAPI IMPL_GetTextExtentPointA(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	return IMPL_GetTextExtentPoint32A(hdc, lpString, cbString, lpSize);
}

BOOL WINAPI IMPL_GetTextExtentPointW(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	return IMPL_GetTextExtentPoint32W(hdc, lpString, cbString, lpSize);
}

HFONT WINAPI IMPL_CreateFontA(int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCSTR  lpszFace)
{
	if ((g_Quality > 0) && g_ForceAntialiasedQuality && (!IsFontExcluded(lpszFace)))
		fdwQuality = ANTIALIASED_QUALITY;
	return ORIG_CreateFontA(nHeight, nWidth, nEscapement, nOrientation, fnWeight, fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily, lpszFace);
}

HFONT WINAPI IMPL_CreateFontW(int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCWSTR lpszFace)
{
	if ((g_Quality > 0) && g_ForceAntialiasedQuality && (!IsFontExcluded(lpszFace)))
		fdwQuality = ANTIALIASED_QUALITY;
	return ORIG_CreateFontW(nHeight, nWidth, nEscapement, nOrientation, fnWeight, fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily, lpszFace);
}

HFONT WINAPI IMPL_CreateFontIndirectA(CONST LOGFONTA *lplf)
{
	LOGFONTA lf;
	if ((g_Quality > 0) && g_ForceAntialiasedQuality && !IsFontExcluded(lplf->lfFaceName)) {
		lf = *lplf;
		lf.lfQuality = ANTIALIASED_QUALITY;
		return ORIG_CreateFontIndirectA(&lf);
		//lplf = &lf;
	}
	return ORIG_CreateFontIndirectA(lplf);
}

HFONT WINAPI IMPL_CreateFontIndirectW(CONST LOGFONTW *lplf)
{
	LOGFONTW lf;
	if ((g_Quality > 0) && g_ForceAntialiasedQuality && !IsFontExcluded(lplf->lfFaceName)) {
		lf = *lplf;
		lf.lfQuality = ANTIALIASED_QUALITY;
		return ORIG_CreateFontIndirectW(&lf);
		//lplf = &lf;
	}
	return ORIG_CreateFontIndirectW(lplf);
}


// Windows 2000p
BOOL WINAPI IMPL_TextOutA(HDC hdc, int nXStart, int nYStart, LPCSTR lpString, UINT cbString)
{
	if (g_IsWinXPorLater) {
		return ORIG_TextOutA(hdc, nXStart, nYStart, lpString, cbString);
	} else {
		return IMPL_ExtTextOutA(hdc, nXStart, nYStart, NULL, NULL, lpString, cbString, NULL);
	}
}

BOOL WINAPI IMPL_TextOutW(HDC hdc, int nXStart, int nYStart, LPCWSTR lpString, UINT cbString)
{
	if (g_IsWinXPorLater) {
		return ORIG_TextOutW(hdc, nXStart, nYStart, lpString, cbString);
	} else {
		return IMPL_ExtTextOutW(hdc, nXStart, nYStart, NULL, NULL, lpString, cbString, NULL);
	}
}

//gdi32.dll/win2ktďN֐
void ConvertDxArray(UINT CodePage, LPCSTR lpString, const int* lpDxA, int cbString, int* lpDxW, int)
{
	LPCSTR lpEnd = lpString + cbString;
	while(lpString < lpEnd) {
		*lpDxW = *lpDxA++;
		if(IsDBCSLeadByteEx(CodePage, *lpString)) {
			*lpDxW += *lpDxA++;
			lpString++;
		}
		lpDxW++;
		lpString++;
	}
}

// ANSI->UnicodeɕϊExtTextOutWɓExtTextOutAiWindows 2000pj
BOOL WINAPI IMPL_ExtTextOutA(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPCSTR lpString, UINT cbString, CONST INT *lpDx)
{
#if 0//#ifdef _DEBUG
{
	LPSTR pTmp = new char[cbString+1];
	memcpy(pTmp, lpString, cbString);
	pTmp[cbString] = 0;
	if(lprc)
		TRACE(_T("IMPL_ExtTextOutA(%d, %d, %x, {%d,%d,%d,%d}, \"%hs\")\n"), nXStart, nYStart, fuOptions,
				lprc->left,lprc->top,lprc->right,lprc->bottom, pTmp);
	else
		TRACE(_T("IMPL_ExtTextOutA(%d, %d, %x, <null>, \"%hs\")\n"), nXStart, nYStart, fuOptions, pTmp);
	delete[] pTmp;
}
#endif

	if (g_IsWinXPorLater) {
		return ORIG_ExtTextOutA(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
	} else {
		LPWSTR lpszUnicode;
		int bufferLength;
		BOOL result;
		bufferLength = MultiByteToWideChar(CP_ACP, 0, lpString, cbString, 0, 0);
	//	lpszUnicode = (LPWSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, bufferLength * 2);
		lpszUnicode = (LPWSTR)malloc(bufferLength * 2);
		MultiByteToWideChar(CP_ACP, 0, lpString, cbString, lpszUnicode, bufferLength);

		UINT cp = _getmbcp();
		int* lpDxW = NULL;
		if(lpDx && cbString && cp) {
			lpDxW = (int*)calloc(sizeof(int), cbString);
			ConvertDxArray(cp, lpString, lpDx, cbString, lpDxW, 0);
			lpDx = lpDxW;
		}

		result = IMPL_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, (LPCWSTR)lpszUnicode, bufferLength, lpDx);
	//	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpszUnicode);
		free(lpszUnicode);
		free(lpDxW);	// free(NULL)͖薳ۏ؂Ă͂
		return result;
	}
}

BOOL WINAPI _RealGetTextExtentPoint32A(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize, const TEXTMETRICA* lptm, INT* lpDx)
{
	//ANSIłłlptmlpDx͗pȂ
//	Assert(lptm || lpDx);
	int cchStringW = MultiByteToWideChar(CP_ACP, 0, lpString, cbString, NULL, 0);
	LPWSTR lpStringW = new WCHAR[cchStringW + 1];
	if(!lpStringW) {
		SetLastError(ERROR_NOT_ENOUGH_MEMORY);
		return FALSE;
	}

	MultiByteToWideChar(CP_ACP, 0, lpString, cbString, lpStringW, cchStringW + 1);
	BOOL ret = _RealGetTextExtentPoint32W(hdc, lpStringW, cchStringW, lpSize, NULL, NULL);
	delete[] lpStringW;
	return ret;
}

//mȃeLXg̃TCYԂ
//ɐmȕ`ʒuvZlpDxɕԂ
//(lpDxExtTextOutɓnĕ`悷ƃYȂ)
BOOL WINAPI _RealGetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize, const TEXTMETRICW* lptm, INT* lpDx)
{
	if(!hdc || !lpString || !cbString || !lpSize) {
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
	}

	switch(GetObjectType(hdc)) {
	case OBJ_DC:
	case OBJ_MEMDC:
	case OBJ_METADC:
	case OBJ_ENHMETADC:
		break;
	default:
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
	}

	TEXTMETRICW _tm;
	//IMPL_ExtTextOutW̌Ăяoɂ͊Ɏ擾ς݂TEXTMETRICg
	if(!lptm) {
		GetTextMetrics(hdc, &_tm);
		lptm = &_tm;
	}

	lpSize->cx = 0;
	lpSize->cy = lptm->tmHeight;
	LPCWSTR lpEnd = lpString + cbString;
	for(; lpString < lpEnd; lpString++) {
		ABCFLOAT abcWidth = { 0 };
		GetCharABCWidthsFloatW(hdc, *lpString, *lpString, &abcWidth);
		const float f = abcWidth.abcfA
						+ abcWidth.abcfB
						+ abcWidth.abcfC
						+ 0.01f;
		lpSize->cx += (LONG)f;
		if(lpDx) {
			*lpDx++ = (int)f;
		}
	}
	return TRUE;
}


/*******************************************************************************
*	LCExtTextOutiДj̎
*	BOOL ExtTextOut(
*	  HDC hdc,          // foCXReLXg̃nh
*	  int X,            // Jnʒui_j x W
*	  int Y,            // Jnʒui_j y W
*	  UINT fuOptions,   // `̈̎g̃IvV
*	  CONST RECT *lprc, // `̈̓\̂ւ̃|C^
*	  LPCTSTR lpString, // 
*	  UINT cbCount,     // 
*	  CONST INT *lpDx   // Ԋu̓z
*	  );
*******************************************************************************/

typedef enum {
	ETOE_OK				= 0,
	ETOE_CREATEDC		= 1,
	ETOE_SETFONT		= 2,
	ETOE_CREATEDIB		= 3,
	ETOE_INVALIDARG		= 11,
	ETOE_ROTATION		= 12,
	ETOE_LARGESIZE		= 13,
	ETOE_INVALIDHDC		= 14,
	ETOE_ROTATEFONT		= 15,
	ETOE_NOAREA			= 16,
	ETOE_GETTEXTEXTENT	= 17,
	ETOE_CACHE			= 21,
} ExtTextOut_ErrorCode;

//OhL
#define _TRY()
#define _THROW(code)	error = (code); goto ExtTextOutW_THRU
#define _CATCH()		ExtTextOutW_THRU:

BOOL WINAPI IMPL_ExtTextOutW(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPCWSTR lpString, UINT cbString, CONST INT *lpDx)
{
_TRY();


	ExtTextOut_ErrorCode error = ETOE_OK;
	POINT	curPos = { nXStart, nYStart };
	POINT	destPos;
	SIZE	destSize;
	POINT	canvasPos;
	HFONT	hCurFont  = NULL;
	HGDIOBJ	hPrevFont = NULL;
	ETOCache* pCache = g_Cache.GetPtr();

	HDC		hCanvasDC = NULL;//g傳ꂽ1bit
	SIZE	canvasSize;
	BYTE*	lpCanvasPixels  = NULL;
	HBITMAP	hBmp1      = NULL;
	HGDIOBJ	hPrevBmp1  = NULL;
	
	HDC		hBufferDC = NULL;//̃TCY32bit
	BYTE*	lpBufferPixels  = NULL;
	SIZE	bufferSize;
	HBITMAP	hBmp32      = NULL;
	HGDIOBJ	hPrevBmp32  = NULL;

	XFORM	xformNoTrns;
	XFORM	xformScale = {1.0f,0.0f,  0.0f,1.0f,  0.0f,0.0f};
	UINT	align;
	SIZE	textSize;
	TEXTMETRIC	tm = { 0 };
	LOGFONT	lf = { 0 };
	RECT	rc;
	int*	lpDxTemp = NULL;

	if(!pCache) {_THROW(ETOE_CACHE);}

//***************************** ̃`FbN ******************************
	if(lpString == NULL || cbString == 0 || g_Quality==0) { _THROW(ETOE_INVALIDARG);}
	if(!IsValidDC(hdc)) { _THROW(ETOE_INVALIDHDC);}
	
//***************************** HDC쐬 ******************************
	hCanvasDC = pCache->CreateDC(NUM_ETO_CANVAS);
	if(!hCanvasDC) {_THROW(ETOE_CREATEDC);}
	hBufferDC = pCache->CreateDC(NUM_ETO_BUFFER);
	if(!hBufferDC) {_THROW(ETOE_CREATEDC);}

//***************************** `ʒuƍWϊ ******************************
	align = GetTextAlign(hdc);
	if(align & TA_UPDATECP) {GetCurrentPositionEx(hdc, &curPos);}

	GetWorldTransform(hdc, &xformNoTrns);
	if(abs(xformNoTrns.eM12) > 0.1f || abs(xformNoTrns.eM21) > 0.1f) {
		_THROW(ETOE_ROTATION);// ]ϊ̓T|[głȂ
	}
	xformNoTrns.eDx = 0.0f; // ړϊ
	xformNoTrns.eDy = 0.0f;
	xformScale.eM11 = xformNoTrns.eM11 * g_Scale;//scaling
	xformScale.eM22 = xformNoTrns.eM22 * g_Scale;
	SetGraphicsMode(hCanvasDC, GM_ADVANCED);
	SetWorldTransform(hCanvasDC, &xformScale);
	SetGraphicsMode(hBufferDC, GM_ADVANCED);
	SetWorldTransform(hBufferDC, &xformNoTrns);

//***************************** ݂̃tHg擾 ******************************
	//copy font
	//tHg̓RXg傫AxGetCurrentObjectGetTextMetricŝ
	//̂1x擾Ďg
	hCurFont = (HFONT)GetCurrentObject(hdc, OBJ_FONT);
	if (!hCurFont) {
		// NULL̏ꍇSystemݒ肵Ă
		hCurFont = (HFONT)GetStockObject(SYSTEM_FONT);
		if (!hCurFont) {_THROW(ETOE_SETFONT);}// SystemNULL̏ꍇ̓G[Ԃ
	}
	hPrevFont = SelectObject(hCanvasDC, hCurFont);
	GetTextMetrics(hdc, &tm);
	GetObject(hCurFont,sizeof(LOGFONT), &lf);

//***************************** Ԋu̐ݒ ******************************
	//GetTextExtentPointnSetTextCharacterExtraKvƂ炵
	SetTextCharacterExtra(hCanvasDC, GetTextCharacterExtra(hdc));
	//text size
	if(fuOptions & ETO_GLYPH_INDEX) {
		if(!GetTextExtentPointI(hCanvasDC, (LPWORD)lpString, (int)cbString, &textSize)) {
			_THROW(ETOE_GETTEXTEXTENT);
		}
	} else {
		//GetTextExtentPointWTeraPad on win2kŐ`悳Ȃ
		//rbg}bvtHgTransformɑΉĂȂH
		if(!lpDx) {
			lpDxTemp = (int*)calloc(sizeof(int), cbString);
			if(!lpDxTemp) {_THROW(ETOE_GETTEXTEXTENT);}
		}
		if(!_RealGetTextExtentPoint32W(hCanvasDC, lpString, (int)cbString, &textSize, &tm, lpDxTemp)) {
			_THROW(ETOE_GETTEXTEXTENT);
		}
	}
//***************************** ԍsԂ̐ݒ ******************************
	if(lpDx) {
		textSize.cx = 0;
		if(fuOptions & ETO_PDY) {
			for(UINT i=0; i < cbString; textSize.cx += lpDx[i],i+=2);
		} else {
			for(UINT i=0; i < cbString; textSize.cx += lpDx[i++]);
		}
	}

//***************************** Xg ******************************
	// C^bÑXg𑫂(\̖̂OABC
	// Ql: http://bugzilla.mozilla.gr.jp/show_bug.cgi?id=3253
	if (tm.tmItalic) {
		ABC abcWidth={0, 0, 0};
		GetCharABCWidthsW(hdc, lpString[cbString-1], lpString[cbString-1], &abcWidth);
		textSize.cx += tm.tmOverhang - abcWidth.abcC;
	}

//***************************** ŏIIȕ̃TCY`FbN ******************************
	if (g_MaxHeight > 0) {
		//max 26pixel
		if(textSize.cy * xformNoTrns.eM22 >= g_MaxHeight) {
			_THROW(ETOE_LARGESIZE);//throw large size
		}
	}

//***************************** c̏ ******************************
// ܂ĂȂ̂ŁAbIɎg悤ɃG[𓊂
	if (lf.lfEscapement != 0) {_THROW(ETOE_ROTATEFONT);}

//***************************** ŏIIȋ`̌vZ ******************************
	//rectangle
	//trace(L"OrigTextSize=%d %d\n", textSize.cx, textSize.cy);
	//trace(L"OrigCursor=%d %d\n", curPos.x, curPos.y);
	{
		UINT horiz;
		UINT vert;
		horiz = align & (TA_LEFT|TA_RIGHT|TA_CENTER);
		vert  = align & (TA_BASELINE|TA_TOP);//TA_BOTTOM

		if(horiz == TA_CENTER) {
			rc.left  = curPos.x - div_ceil(textSize.cx, 2);
			rc.right = curPos.x + div_ceil(textSize.cx, 2);
			//no move
		}
		else if(horiz == TA_RIGHT) {
			rc.left  = curPos.x - textSize.cx;
			rc.right = curPos.x;
			curPos.x -= textSize.cx;//move pos
		}
		else {
			rc.left  = curPos.x;
			rc.right = curPos.x + textSize.cx;
			curPos.x += textSize.cx;//move pos
		}
		if(vert == TA_BASELINE) {
			TEXTMETRIC& metric = tm;
			rc.top = curPos.y - metric.tmAscent;
			rc.bottom = curPos.y + metric.tmDescent;
			//trace(L"ascent=%d descent=%d\n", metric.tmAscent, metric.tmDescent);
		}
		else {
			rc.top = curPos.y;
			rc.bottom = curPos.y + textSize.cy;
		}
		canvasPos.x = canvasPos.y = 0;

//***************************** NbsǑvZ ******************************
		if(lprc && (fuOptions & ETO_CLIPPED)) {
			if(rc.left < lprc->left) {
				canvasPos.x -= div_ceil( (int)((lprc->left - rc.left) * xformScale.eM11), g_Scale);
				rc.left = lprc->left;
			}
			if(rc.right > lprc->right) {
				if(horiz == TA_RIGHT)
					canvasPos.x -= div_ceil( (int)((rc.right - lprc->right) * xformScale.eM11), g_Scale);
				rc.right = lprc->right;
			}
			if(rc.top < lprc->top) {
				canvasPos.y -= div_ceil( (int)((lprc->top - rc.top) * xformScale.eM22), g_Scale);
				rc.top = lprc->top;
			}
			if(rc.bottom > lprc->bottom) {
				rc.bottom = lprc->bottom;
			}
			//trace(L"ClipRect=%d %d %d %d\n", lprc->left, lprc->top, lprc->right, lprc->bottom);
		}
	}

//***************************** `DIB쐬 ******************************
	destPos.x = rc.left;
	destPos.y = rc.top;
	destSize.cx = rc.right - rc.left;
	destSize.cy = rc.bottom - rc.top;
	canvasSize.cx = (int)(destSize.cx * xformScale.eM11);
	canvasSize.cy = (int)(destSize.cy * xformScale.eM22);
	bufferSize.cx = (int)(destSize.cx * xformNoTrns.eM11);
	bufferSize.cy = (int)(destSize.cy * xformNoTrns.eM22);

	//trace(L"MovedCursor=%d %d\n", curPos.x, curPos.y);
	//trace(L"TargetRect=%d %d %d %d\n", rc.left, rc.top, rc.right, rc.bottom);
	//trace(L"DestPos=%dx%d Size=%dx%d\n", destPos.x, destPos.y, destSize.cx, destSize.cy);
	//trace(L"CanvasPos=%dx%d Size=%dx%d\n", canvasPos.x, canvasPos.y, canvasSize.cx, canvasSize.cy);

	if(destSize.cx < 1 || destSize.cy < 1) {_THROW(ETOE_NOAREA); }//0ł

	hBmp1 = pCache->CreateDIB(NUM_ETO_CANVAS,canvasSize.cx, canvasSize.cy, 1, &lpCanvasPixels);
	if(!hBmp1) {_THROW(ETOE_CREATEDIB);}
	hPrevBmp1 = SelectObject(hCanvasDC, hBmp1);
	hBmp32 = pCache->CreateDIB(NUM_ETO_BUFFER,bufferSize.cx, bufferSize.cy, 32, &lpBufferPixels);
	if(!hBmp32) {_THROW(ETOE_CREATEDIB);}
	hPrevBmp32 = SelectObject(hBufferDC, hBmp32);

//***************************** wi̓hԂ/BitBlt ******************************
	{
		const BOOL fillrect = (lprc && (fuOptions & ETO_OPAQUE));//wihԂǂ

		//clear bitmap
		if(fillrect || GetBkMode(hdc) == OPAQUE) {
			FillBuffer(pCache, lpBufferPixels,bufferSize.cx,bufferSize.cy, GetBkColor(hdc));

			if(fillrect) {ORIG_ExtTextOutW(hdc, 0,0, ETO_OPAQUE, lprc, NULL, 0, NULL);}
		}
		else {
			SetBkMode(hBufferDC, TRANSPARENT);
			BitBlt(hBufferDC,0,0,destSize.cx,destSize.cy, hdc,destPos.x,destPos.y, SRCCOPY);
		}
	}

//***************************** F/AC̐ݒ ******************************
//	SetTextColor(hCanvasDC, GetTextColor(hdc));
	SetTextAlign(hCanvasDC, TA_LEFT | TA_TOP);

//***************************** ` ******************************
	//textout
	ZeroCanvas(pCache, lpCanvasPixels, canvasSize.cx,canvasSize.cy);

//	for (UINT w=0; w<=g_Weight; w++) {
	ORIG_ExtTextOutW(hCanvasDC, canvasPos.x, canvasPos.y, fuOptions, NULL, lpString, cbString, lpDx ? lpDx:lpDxTemp);
//	}

//***************************** k/GbW ******************************
	//SaveDIB(L"a0.bmp", canvasSize.cx, canvasSize.cy, lpPixels);

	ReductDIB(pCache, lpBufferPixels, lpCanvasPixels, canvasSize.cx, canvasSize.cy, GetTextColor(hdc));
	//EnhanceEdges(pCache, lpPixels, canvasSize.cx, canvasSize.cy);

	//SaveDIB(L"a1.bmp", canvasSize.cx, canvasSize.cy, lpPixels);

//***************************** `bitblt ******************************
	SetWorldTransform(hBufferDC, &xformNoTrns);
	BitBlt(hdc, destPos.x, destPos.y, destSize.cx, destSize.cy, hBufferDC, 0,0, SRCCOPY);

//***************************** J[\ړ ******************************
	if(align & TA_UPDATECP) {MoveToEx(hdc, curPos.x, curPos.y, NULL);}

//***************************** G[ ******************************
_CATCH();
	free(lpDxTemp);
	if(hPrevBmp1) SelectObject(hCanvasDC, hPrevBmp1);
	if(hPrevBmp32) SelectObject(hBufferDC, hPrevBmp32);
	if(hPrevFont) SelectObject(hCanvasDC, hPrevFont);
	if(error == ETOE_OK) return TRUE;
	
	return ORIG_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
}

//EOF
